//Datei: INTERUPT.C
//
// Interruptbehandlung fr Timer0 und EEPROM
//
// Holger Klabunde
// Copyright 2000
// 05.05.2001
// Compiler CC5x

#include "prozess.h"      /* Der verwendete Prozessor */

#include "protos.h"
#include "backcnt.h"

#include <int16CXX.H>

#pragma origin 4

interrupt int_server( void)
{
//Alle wichtigen Register retten
 int_save_registers    // W, STATUS (and PCLATH)

//############################
//Beginn Timerinterrupt
//############################
 if(T0IF) //War ein Timer Interrupt
  {
   tastbuf=(~PORTA)&0x1F; //Tastatur lesen, lowaktiv

   if(!PORTB.6) //Ein/Aus gedrckt ?                       
    { tastbuf|=ONOFF; }
    
   if(tastbuf>0)
    {
     boing++; //Flag INT war da setzen und INT's zhlen
   			  //wenn Taste gedrckt wurde
     if(boing==0) boing++; //boing=0 bei berlauf vermeiden !
    }
   else boing=0;          //Keine Taste gedrckt, Tastaturrepeat aus
   
   if(gogo<TICKS) //Countdown aktiviert
    {

     gogo++;
     if(gogo==TICKS) //Eine Sekunde um ?
      {

       if(countdown>0) //Zhler noch nicht auf 0 ?
        {
         gogo=ENABLE; //nchste Sekunde starten
         countdown--; //Countdown runterzhlen
         if(countdown==0) gogo=ENDCOUNTDOWN; //Countdown beenden in main() !
        }

      } //if(gogo==TICKS)

    } //if(gogo<TICKS)
    
   T0IF=0; //Interrupt Flag lschen
  }
//############################
//Ende Timerinterrupt
//############################

//############################
//Beginn EEPROM-Interrupt
//############################
 if(EEIF) //War ein EEPROM Interrupt
  {
   EEIF=0; //Interrupt Flag lschen
   EEIE=0; //Interrupt selbst lschen
 	  //Quasi als Schreibschutz frs EEPROM
  }
//############################
//Ende EEPROM-Interrupt
//############################

//Alle wichtigen Register wiederherstellen
 int_restore_registers // W, STATUS (and PCLATH)
}

